package appliaction;

import javafx.application.Application;
import javafx.stage.Stage;
import model.KiwiModelHandler;
import view.KiwiViewHandler;
import viewModel.KiwiViewModelHandler;

public class MainKiwi extends Application{
	
	private KiwiModelHandler modelHandler;
	private KiwiViewModelHandler viewModelHandler;
	private KiwiViewHandler viewHandler;

	@Override
	public void start(Stage primaryStage) throws Exception {
		this.modelHandler = new KiwiModelHandler();
		this.modelHandler.testModels();
		this.viewModelHandler = new KiwiViewModelHandler(modelHandler);
		this.viewHandler = new KiwiViewHandler(primaryStage, viewModelHandler);
		
		viewHandler.start();
	}
	
	public static void main(String[] args) {
		launch(args);
	}
	
	@Override
	public void stop(){
	    System.exit(0);
	}
}
