package model.lightController.artNet.artNetPakages;

public class ArtNetCodeLibrary {
    public static enum OpCodes {
        OP_POLL((short)0x2000),
        OP_POLL_REPLY((short)0x2100),
        OP_COMMAND((short)0x2400),
        OP_DATA_REQUEST((short)0x2700),
        OP_DATA_REPLY((short)0x2800),
        OP_DMX((short)0x5000);

        public final short opCode;

        private OpCodes(short opCode) {
            this.opCode = opCode;
        }
    }

    public static enum RequestCodes {
        DR_POLL ((short)0x0000),
        DR_URL_PRODUCT ((short)0x0001),
        DR_URL_USER_GUIDE ((short)0x0002),
        DR_URL_SUPPORT ((short)0x0003),
        DR_URL_PERS_UDR ((short)0x0004),
        DR_URL_PERS_GDTF ((short)0x0005),
        DR_PRESET_STATUS ((short)0x8000);

        public final short requestCode;

        private RequestCodes(short requestCode) {
            this.requestCode = requestCode;
        }
    }

    public static enum ArtCommands {
        ART_COM_AP("activatePreset"),
        ART_COM_DP("deactivatePreset"),
        ART_COM_CP("clearPreset"),
        ART_COM_SP("setPreset"),
        ART_COM_SC("setChannelState"),
        ART_COM_AG("activateGroup"),
        ART_COM_DG("deactivateGroup"),
        ART_COM_PA("presetActivated"),
        ART_COM_PD("presetDeactivated");

        public final String command;

        private ArtCommands(String command) {
            this.command = command;
        }
    }

}
