package model.lightingScene.composition;

import java.util.Map;

import model.generic.PropertyItem;

import java.util.HashMap;

public class CompositionRepository extends PropertyItem {
    private Map<String, Composition> compositions;

    public CompositionRepository() {
        this.compositions = new HashMap<>();
    }

    public void addComposition(Composition composition) {
		this.compositions.put(composition.getName(), composition);
		this.propertySupport.firePropertyChange("compositions", null, composition);
	}
	
	public Composition getComposition(String name) {
		return compositions.get(name);
	}
	
	public void removeComposition(String name) {
		this.propertySupport.firePropertyChange("compositions", this.compositions.get(name), null);
		this.compositions.remove(name);
	}
	
	public Map<String, Composition> getCompositionMap() {
		return this.compositions;
	}
}
