package model.preset;

import java.util.Map;

import model.generic.PropertyItem;

import java.util.HashMap;

public class PresetRepository extends PropertyItem{
	Map<Integer, Preset> presets;
	
	public PresetRepository() {
		this.presets = new HashMap<>();
	}
	
	public void loadPrests() {
		for(int i = 0; i < 6; i++) {
			this.addPreset(new Preset());
		}
	}
	
	public void addPreset(Preset preset) {
		this.presets.put(preset.getId(), preset);
		this.propertySupport.firePropertyChange("presets", null, preset);
	}
	
	public void removePreset(Preset preset) {
		preset.deactivate();
		this.propertySupport.firePropertyChange("presets", preset, null);
		this.presets.remove(preset.getId());
	}
	
	public Preset getPreset(int presetId) {
		return this.presets.get(presetId);
	}
	
	public Map<Integer, Preset> getPresetsMap() {
		return this.presets;
	}
}
