package view.test;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;

public class TestUI extends Application{
	
	protected final PropertyChangeSupport propertySupport = new PropertyChangeSupport(this);
	private PropertyChangeListener fixtureListener;
	public void addPropertyChangeListener(PropertyChangeListener listener) {
		propertySupport.addPropertyChangeListener(listener);
	}
	
	public void removePropertyChangeListener(PropertyChangeListener listener) {
		propertySupport.removePropertyChangeListener(listener);
	}
	
	public void printText(String text) {
		System.out.println(text);
	}
	
	public TestUI() {
		this.fixtureListener = new PropertyChangeListener() {
            @Override
            public void propertyChange(PropertyChangeEvent event) {
            	if(event.getPropertyName().equals("Test")) {
					if((boolean) event.getNewValue()) {
						printText("True");
					} else {
						printText("False");
					}
        		}
            }
		};
	}
	
	
	public static void main(String[] args) {
		launch(args);

	}

	@Override
	public void start(Stage stage) throws Exception {
		
		ObservableList<String> options = FXCollections.observableArrayList(
	        "Option 1",
	        "Option 2",
	        "Option 3"
	    );
		ComboBox<String> comboBox = new ComboBox<>(options);
		comboBox.setOnAction(event -> {
			propertySupport.firePropertyChange("Test", true, false);
		});
		
		Button buttonAnmelden = new Button("Anmelden");
		buttonAnmelden.setOnAction(event -> {
			this.addPropertyChangeListener(fixtureListener);
		});
		
		Button buttonAbmelden = new Button("Abmelden");
		buttonAbmelden.setOnAction(event -> {
			this.removePropertyChangeListener(fixtureListener);
		});
		
		
		Pane root = new Pane();
		HBox hBox = new HBox(comboBox, buttonAnmelden, buttonAbmelden);
		root.getChildren().add(hBox);
		Scene scene = new Scene(root);
		stage.setMinWidth(800);
		stage.setMinHeight(625);
		stage.setScene(scene);
		stage.show();
		
	}

}
