package viewModel;

import model.KiwiModelHandler;
import viewModel.fixture.FixtureGroupRepositoryVM;
import viewModel.fixture.FixtureRepositoryVM;
import viewModel.group.GroupRepositoryVM;
import viewModel.lightController.ArtNetControlleVM;

public class KiwiViewModelHandler {
	private KiwiModelHandler modelHandler;
	private GroupRepositoryVM groupRepositoryVM;
	private FixtureRepositoryVM fixtureRepositoryVM;
	private FixtureGroupRepositoryVM fixtureGroupRepositoryVM;
	private ArtNetControlleVM artNetControlleVM;
	
	public KiwiViewModelHandler(KiwiModelHandler modelHandler) {
		this.modelHandler = modelHandler;
		groupRepositoryVM = new GroupRepositoryVM(KiwiModelHandler.getGroupReposirory());
		fixtureRepositoryVM = new FixtureRepositoryVM(KiwiModelHandler.getFixtureRepository());
		fixtureGroupRepositoryVM = new FixtureGroupRepositoryVM(KiwiModelHandler.getGroupReposirory());
		artNetControlleVM =  new ArtNetControlleVM(KiwiModelHandler.getArtNetController());
	}

	public GroupRepositoryVM getGroupRepositoryVM() {
		return groupRepositoryVM;
	}
	
	public FixtureRepositoryVM getFixtureRepositoryVM() {
		return fixtureRepositoryVM;
	}
	
	public FixtureGroupRepositoryVM getFixtureGroupRepositoryVM() {
		return fixtureGroupRepositoryVM;
	}
	
	public ArtNetControlleVM getArtNetControlleVM() {
		return this.artNetControlleVM;
	}
	
	public void clearRepros() {
		this.modelHandler.clearRepros();
	}
}
