package viewModel.lightController;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javafx.beans.property.BooleanProperty;
import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleBooleanProperty;
import javafx.beans.property.SimpleObjectProperty;
import model.lightController.artNet.artNetNode.ArtNetNodeRepository;
import viewModel.group.GroupVM.State;

public class ArtNetNodeRepositoryVM {
	private ArtNetNodeRepository artNetNodeRepository;
	private BooleanProperty nodesConnected = new SimpleBooleanProperty(false);
	private ObjectProperty<State> connectState = new SimpleObjectProperty<>(State.OFF);
	private PropertyChangeListener nodeRepositoryListener;
	
	public ArtNetNodeRepositoryVM(ArtNetNodeRepository artNetNodeRepository) {
		this.artNetNodeRepository = artNetNodeRepository;
		this.nodeRepositoryListener = new PropertyChangeListener() {
			@Override
            public void propertyChange(PropertyChangeEvent event) {
				if(event.getPropertyName().equals("nodesConnected")) {
            		nodesConnected.set((boolean) event.getNewValue());
            		if((boolean) event.getNewValue()) {
            			connectState.set(State.ON);
            		} else {
            			if(connectState.get() == State.OFF) {
            				connectState.set(State.MID);
            			} else {
            				connectState.set(State.OFF);
            			}
            			
            		}
            	}
            }
		};
		
		this.artNetNodeRepository.addPropertyChangeListener(this.nodeRepositoryListener);
	}
	
	public boolean isNodesConneted() {
		return this.nodesConnected.get();
	}
	
	public BooleanProperty nodesConnectedProperty() {
		return this.nodesConnected;
	}
	
	public ObjectProperty<State> connectStateProperty() {
		return this.connectState;
	}
}
