#include <Arduino.h>
#include <EEPROM.h>
#include "config.h"
#include <ArduinoSTL.h>
#include "set.h"

Set test;

// structs

struct channel
{
  bool isActive;
  uint8_t value;
};

struct storeDate
{
    uint8_t state;
    channel channels[2];
};

// varables
int buttons[] = {BUTTON_1_PININ, BUTTON_2_PININ, BUTTON_3_PININ, BUTTON_4_PININ, BUTTON_5_PININ, BUTTON_6_PININ};
storeDate saveData;
storeDate loadData;
channel saveChannel;



// setup functions
void setupButtons()
{
  for(int i = 0; i < NUMBER_OF_PRESETS; i++){
    pinMode(buttons[i], INPUT_PULLUP);
  }
}

// check functinos
void checkButtonIsPressed()
{
    for(int i = 0; i < NUMBER_OF_PRESETS; i++) {
        if(digitalRead(buttons[i]) == LOW) {
            switch(i)
            {
                case 0:
                    Serial.println("EEPROM leeren.");
                    for(int i = 0; i<10; i++) {
                        EEPROM.update(i, 0x00);
                    }
                    break;
                case 1:
                    saveChannel = {false, 0};
                    saveData.state = 0;
                    saveData.channels[0] = saveChannel;
                    saveChannel = {false, 0};
                    saveData.channels[1] = saveChannel;
                    Serial.println("Das Strukt mit 0er Daten wird in den EEPROM geschrieben.");
                    Serial.println("S:" + String(saveData.state) + " C1-U:" + String(saveData.channels[0].isActive) + " C1-V:" + String(saveData.channels[0].value));
                    Serial.println("S:" + String(saveData.state) + " C2-U:" + String(saveData.channels[1].isActive) + " C2-V:" + String(saveData.channels[1].value));
                    //EEPROM.put(0, saveData);
                    break;
                case 2:
                    saveChannel = {true, 250};
                    saveData.state = 1;
                    saveData.channels[0] = saveChannel;
                    saveChannel = {false, 30};
                    saveData.channels[1] = saveChannel;
                    Serial.println("Das Strukt mit gefüllten Daten wird in den EEPROM geschrieben.");
                    Serial.println("S:" + String(saveData.state) + " C1-U:" + String(saveData.channels[0].isActive) + " C1-V:" + String(saveData.channels[0].value));
                    Serial.println("S:" + String(saveData.state) + " C2-U:" + String(saveData.channels[1].isActive) + " C2-V:" + String(saveData.channels[1].value));
                    EEPROM.put(0, saveData);
                    break;
                case 3:
                    Serial.println("Die ersten 10 Bytes werden aus den EEPROM geladen.");
                    for(int i = 0; i<10; i++) {
                        Serial.println("Byte " + String(i) + " V: " + String(EEPROM.read(i)));
                    }
                    break;
                case 4:
                    loadData;
                    Serial.println("Das Strukt wird aus den EEPROM geladen.");
                    EEPROM.get(0, loadData);
                    Serial.println("S:" + String(loadData.state) + " C1-U:" + String(loadData.channels[0].isActive) + " C1-V:" + String(loadData.channels[0].value));
                    Serial.println("S:" + String(loadData.state) + " C2-U:" + String(loadData.channels[1].isActive) + " C2-V:" + String(loadData.channels[1].value));
                    break;
                case 5:
                    Serial.println("Inhalts des save structs:");
                    Serial.println("S:" + String(saveData.state) + " C1-U:" + String(saveData.channels[0].isActive) + " C1-V:" + String(saveData.channels[0].value));
                    Serial.println("S:" + String(saveData.state) + " C2-U:" + String(saveData.channels[1].isActive) + " C2-V:" + String(saveData.channels[1].value));
                    break;
            }
            while(digitalRead(buttons[i]) == LOW){}
        }
    }
}

void setup()
{
    Serial.begin(9600);
    setupButtons();
}

void loop()
{
    checkButtonIsPressed();
}
